



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>动态树之LCT(link-cut tree)讲解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">动态树之LCT(link-cut tree)讲解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 18:50:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　动态树是一类要求维护森林的连通性的题的总称，这类问题要求维护某个点到根的某些数据，支持树的切分，合并，以及对子树的某些操作。其中解决这一问题的某些简化版（不包括对子树的操作）的基础数据结构就是LCT(link-cut tree)。</p>
<p>　　LCT的大体思想类似于树链剖分中的轻重链剖分(轻重链剖分请移步http://www.cnblogs.com/BLADEVIL/p/3479713.html)，轻重链剖分是处理出重链来，由于重链的定义和树链剖分是处理静态树所限，重链不会变化，变化的只是重链上的边或点的权值，由于这个性质，我们用线段树来维护树链剖分中的重链，但是LCT解决的是动态树问题（包含静态树），所以需要用更灵活的splay来维护这里的&ldquo;重链&rdquo;(splay请移步http://www.cnblogs.com/BLADEVIL/p/3464458.html)。</p>
<p><strong>定义：</strong></p>
<p>　　首先来定义一些量：</p>
<p>　　access(X)：表示访问X点（之后会有说明）。</p>
<p>　　Preferred child（偏爱子节点）：如果最后被访问的点在X的儿子P节点的子树中，那么称P为X的Preferred child，如果一个点被访问，他的Preferred child为null(即没有)。</p>
<p>　　Preferred edge（偏爱边）：每个点到自己的Preferred child的边被称为Preferred edge。</p>
<p>　　Preferred path（偏爱路径）：由Preferred edge组成的不可延伸的路径称为Preferred path。</p>
<p>这样我们可以发现一些比较显然的性质，每个点在且仅在一条Preferred path上，也就是所有的Preferred path包含了这棵树上的所有的点，这样一颗树就可以由一些Preferred path来表示（类似于轻重链剖分中的重链），我们用splay来维护每个条Preferred path，关键字为深度，也就是每棵splay中的点左子树的深度都比当前点小，右节点的深度都比当前节点</p>
<p>的深度大。这样的每棵splay我们称为Auxiliary tree(辅助树)，每个Auxiliary tree的根节点保存这个Auxiliary tree与上一棵Auxiliary tree中的哪个点相连。这个点称作他的Path parent。</p>
<p>看一个例子</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/584079/201401/08113923-39e5e1c4fe3d4e60a9d67055989c5b9f.png" /></p>
<p>粗的边是Preferred path。那么3-7这个Auxiliary tree中，Path parent为1节点，每个单独的点单独在一棵splay中。以上描述的几个量可以存储这棵树，并且维护相应的信息。</p>
<p><strong>操作：</strong></p>
<p>　　access(X)：首先由于preferred path的定义，如果一个点被访问，那么这个点到根节点的所有的边都会变成preferred edge，由于每个点只有一个preferred child，所以这个点到根节点路径上的所有的点都会和原来的preferred child断开，连接到这条新的preferred path上。假设访问X点，那么先将X点旋转到对应Auxiliary tree的根节点，然后因为被访问的点是没有preferred child的，所以将Auxiliary tree中根节点(X)与右子树的边断掉，左节点保留，将这个树的path parent旋转到对应Auxiliary tree的根节点，断掉右子树，连接这个点与X点，相当于合并两棵Auxiliary tree，不断地重复这一操作，直到当前X所在Auxiliary tree的path parent为null时停止，表示已经完成当前操作。</p>
<div>
<pre class="prettyprint linenums">procedure access(x:longint);<br />
var<br />
    y                    :longint;<br />
begin<br />
    splay(x);//旋转<br />
    while father[x]&lt;&gt;0 do<br />
    begin<br />
        y:=father[x];<br />
        splay(y);<br />
        root[son[y,1]]:=true;//son为子节点son[x,0]代表左子结点，son[x,1]代表右子结点<br />
        root[x]:=false;//当前点是否为对应Auxiliary tree的根节点<br />
        son[y,1]:=x;<br />
        update(y);//更新y点的信息<br />
        splay(x);<br />
    end;<br />
end;</pre>
</div>
<p>　　find root(x)：找到某一点所在树的根节点（维护森林时使用）。只需要access(X)，然后将X节点旋到对应Auxiliary tree的根节点，然后找到这个Auxiliary tree中最左面的点。</p>
<p>　</p>
<div>
<pre class="prettyprint linenums">function find root(x:longint):longint;<br />begin<br />　　access(x);<br />　　splay(x);//将X旋转到根节点<br />　　exit(find(x,-maxlongint));//找到子树中最左面的点<br />end;</pre>
</div>
<p>　　cut(x)：断掉X节点和其父节点相连的边。首先access(X)，然后将X旋转到对应Auxiliary tree的根节点，然后断掉Auxiliary tree中X和左节点相连的边。</p>
<div>
<pre class="prettyprint linenums">procedure cut(x:longint);<br />begin<br />　　access(x);<br />　　splay(x);//旋转x点到根节点<br />　　father[son[x,0]]:=0;<br />　　root[son[x,0]]:=true;//设置左子树根节点<br />　　son[x,0]:=-1;<br />end;</pre>
</div>
<p>　　link(join)(x,y)：连接点x到y点上。即让x称为y的子节点。因为x为y的子节点后，在原x的子树中，x点到根节点的所有的点的深度会被翻转过来，所以先access(x)，然后在对应的Auxiliary tree中将x旋转到根节点，，然后将左子树翻转(splay中的reverse操作)，然后access(y)，将y旋转到对应Auxiliary tree中的根节点，将x连到y就行了。</p>
<div>
<pre class="prettyprint linenums">procedure link(x,y:longint);<br />begin<br />　　access(x);<br />　　splay(x);<br />　　reverse(son[x,0]);<br />　　access(y);<br />　　splay(y);<br />　　son[y,1]:=x;<br />　　father[x]:=y;<br />　　root[x]:=false;<br />end;</pre>
</div>
<p><strong><br /></strong>access操作是LCT的基础，应该熟练掌握并且理解。</p>
<p><strong>时间复杂度：</strong></p>
<p><strong>　　</strong>证明access以及其他操作的时间复杂度是均摊log<sub>2</sub>N的，具体证明参考杨哲的论文《QTREE 解法的一些研究》。</p>
<p>基础题，bzoj 2002:<a href="http://61.187.179.132/JudgeOnline/problem.php?id=2002" rel="external nofollow noreferrer">http://61.187.179.132/JudgeOnline/problem.php?id=2002</a></p>
<div>
<pre class="prettyprint linenums">/**************************************************************<br />
&nbsp;&nbsp;&nbsp;&nbsp;Problem: 2002<br />
&nbsp;&nbsp;&nbsp;&nbsp;User: BLADEVIL<br />
&nbsp;&nbsp;&nbsp;&nbsp;Language: Pascal<br />
&nbsp;&nbsp;&nbsp;&nbsp;Result: Accepted<br />
&nbsp;&nbsp;&nbsp;&nbsp;Time:2372 ms<br />
&nbsp;&nbsp;&nbsp;&nbsp;Memory:4328 kb<br />
****************************************************************/<br />
&nbsp;<br />
//By BLADEVIL<br />
var<br />
&nbsp;&nbsp;&nbsp;&nbsp;n, m&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :longint;<br />
&nbsp;&nbsp;&nbsp;&nbsp;father, size&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :array[-1..200010] of longint;<br />
&nbsp;&nbsp;&nbsp;&nbsp;son&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :array[-1..200010,0..2] of longint;<br />
&nbsp;&nbsp;&nbsp;&nbsp;root&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :array[-1..200010] of boolean;<br />
&nbsp;<br />
procedure update(x:longint);<br />
begin<br />
&nbsp;&nbsp;&nbsp;&nbsp;size[x]:=size[son[x,0]]+size[son[x,1]]+1;<br />
end;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />
procedure left_rotate(x:longint);<br />
var<br />
&nbsp;&nbsp;&nbsp;&nbsp;y&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :longint;<br />
begin<br />
&nbsp;&nbsp;&nbsp;&nbsp;y:=son[x,1];<br />
&nbsp;&nbsp;&nbsp;&nbsp;son[x,1]:=son[y,0];<br />
&nbsp;&nbsp;&nbsp;&nbsp;father[son[x,1]]:=x;<br />
&nbsp;&nbsp;&nbsp;&nbsp;son[y,0]:=x;<br />
&nbsp;&nbsp;&nbsp;&nbsp;if x=son[father[x],0] then<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;son[father[x],0]:=y else<br />
&nbsp;&nbsp;&nbsp;&nbsp;if x=son[father[x],1] then<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;son[father[x],1]:=y;<br />
&nbsp;&nbsp;&nbsp;&nbsp;father[y]:=father[x];<br />
&nbsp;&nbsp;&nbsp;&nbsp;father[x]:=y;<br />
&nbsp;&nbsp;&nbsp;&nbsp;root[y]:=root[x] xor root[y];<br />
&nbsp;&nbsp;&nbsp;&nbsp;root[x]:=root[x] xor root[y];<br />
&nbsp;&nbsp;&nbsp;&nbsp;update(x); update(y);<br />
end;<br />
&nbsp;<br />
procedure right_rotate(x:longint);<br />
var<br />
&nbsp;&nbsp;&nbsp;&nbsp;y&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :longint;<br />
begin<br />
&nbsp;&nbsp;&nbsp;&nbsp;y:=son[x,0];<br />
&nbsp;&nbsp;&nbsp;&nbsp;son[x,0]:=son[y,1];<br />
&nbsp;&nbsp;&nbsp;&nbsp;father[son[x,0]]:=x;<br />
&nbsp;&nbsp;&nbsp;&nbsp;son[y,1]:=x;<br />
&nbsp;&nbsp;&nbsp;&nbsp;if x=son[father[x],0] then<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;son[father[x],0]:=y else<br />
&nbsp;&nbsp;&nbsp;&nbsp;if x=son[father[x],1] then<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;son[father[x],1]:=y;<br />
&nbsp;&nbsp;&nbsp;&nbsp;father[y]:=father[x];<br />
&nbsp;&nbsp;&nbsp;&nbsp;father[x]:=y;<br />
&nbsp;&nbsp;&nbsp;&nbsp;root[y]:=root[y] xor root[x];<br />
&nbsp;&nbsp;&nbsp;&nbsp;root[x]:=root[y] xor root[x];<br />
&nbsp;&nbsp;&nbsp;&nbsp;update(x); update(y);<br />
end;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />
procedure splay(x:longint);<br />
begin<br />
&nbsp;&nbsp;&nbsp;&nbsp;while not root[x] do<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if x=son[father[x],1] then<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;left_rotate(father[x]) else<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;right_rotate(father[x]);<br />
end;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />
procedure access(x:longint);<br />
var<br />
&nbsp;&nbsp;&nbsp;&nbsp;y&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :longint;<br />
begin<br />
&nbsp;&nbsp;&nbsp;&nbsp;splay(x);<br />
&nbsp;&nbsp;&nbsp;&nbsp;while father[x]&lt;&gt;0 do<br />
&nbsp;&nbsp;&nbsp;&nbsp;begin<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;y:=father[x];<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;splay(y);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;root[son[y,1]]:=true;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;root[x]:=false;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;son[y,1]:=x;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;update(y);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;splay(x);<br />
&nbsp;&nbsp;&nbsp;&nbsp;end;<br />
end;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />
procedure init;<br />
var<br />
&nbsp;&nbsp;&nbsp;&nbsp;i&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :longint;<br />
begin<br />
&nbsp;&nbsp;&nbsp;&nbsp;read(n);<br />
&nbsp;&nbsp;&nbsp;&nbsp;for i:=1 to n do<br />
&nbsp;&nbsp;&nbsp;&nbsp;begin<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;read(father[i]);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;father[i]:=father[i]+i;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if father[i]&gt;n then father[i]:=n+1;<br />
&nbsp;&nbsp;&nbsp;&nbsp;end;<br />
&nbsp;&nbsp;&nbsp;&nbsp;read(m);<br />
end;<br />
&nbsp;<br />
procedure main;<br />
var<br />
&nbsp;&nbsp;&nbsp;&nbsp;i&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :longint;<br />
&nbsp;&nbsp;&nbsp;&nbsp;x, y, z&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; :longint;<br />
begin<br />
&nbsp;&nbsp;&nbsp;&nbsp;for i:=1 to n+1 do size[i]:=1;<br />
&nbsp;&nbsp;&nbsp;&nbsp;fillchar(root,sizeof(root),true);<br />
&nbsp;&nbsp;&nbsp;&nbsp;for i:=1 to m do<br />
&nbsp;&nbsp;&nbsp;&nbsp;begin<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;read(x);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if x=1 then<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;begin<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;read(y); inc(y);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;access(y);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;writeln(size[son[y,0]]);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;end else<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;begin<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;read(y,z); inc(y);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;splay(y);<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;father[son[y,0]]:=father[y];<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;root[son[y,0]]:=true;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;son[y,0]:=0;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;size[y]:=size[son[y,1]]+1;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;father[y]:=y+z;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if father[y]&gt;n then father[y]:=n+1;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;end;<br />
&nbsp;&nbsp;&nbsp;&nbsp;end;<br />
end;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />
begin<br />
&nbsp;&nbsp;&nbsp;&nbsp;init;<br />
&nbsp;&nbsp;&nbsp;&nbsp;main;<br />
end.</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k1n259.html">WPF Path</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k16k39.html">解决UINavigationController在pushViewController时出现的&amp;quot&semi;卡顿&amp;quot&semi;问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnnz2kq.html">Python-06-面向对象（基础篇）</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2mxdw8.html">chrome一直提示adobe flash player 因过期而遭阻止</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oojrl8.html">【原创】你知道OneNote的OCR功能吗？office lens为其增大威力，中文也识别</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jrjl4q.html">JavaScript   parseInt函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwelvyq.html">响应性web设计实战总结&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gvmg49.html">《利用python进行数据分析》读书笔记--第十一章 金融和经济数据应用（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9joxmeq.html">Tornado sqlalchemy</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjwk7z9.html">bzoj1015 星球大战</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1jx279.html">01-事件处理简介&sol;UIView拖拽</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1dwm1q.html">Lucene4&period;X 高级应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1w37oq.html">安卓 新版本 获取wifi状态网络是否可用等</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoneknq.html">js中用var与不用var的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4mgxm9.html">linux命令之df</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy6nl39.html">从Firebird2&period;5 迁移到 Firebird3&period;0 手记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j5g0jq.html">c&plus;&plus; primer 笔记 （三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rgo1n9.html">python re正则模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv1rxk8.html">理解 e&period;clientX&comma;e&period;clientY e&period;pageX e&period;pageY e&period;offsetX e&period;offsetY</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vvw60q.html">关于div一侧固定&comma;另一侧自适应</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/3902ej4q.html">常用API&mdash;&mdash;字符串String型函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zk4wd8.html">JDBC API Description</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4pke5q.html">WPF中，Combox的SelectedItem属性绑定成功后，未能默认显示上一次选择的结果。</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9ppgx49.html">0023 Java学习笔记-面向对象-初始化代码块</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7ed0j9.html">CDH离线数据导入solr：利用MapReduceIndexerTool将json文件批量导入到solr</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql1xe09.html">c语言中类型隐性转换的坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rnw7mq.html">linux 命令之grep</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7ej519.html">&lbrack;diango&rsqb;理解django视图工作原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/39021zoq.html">导入项目时，有关&lbrack;2016-04-03 20&colon;38&colon;02 - Dex Loader&rsqb; Unable to execute dex&colon; Multiple dex files 问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ko4n3q.html">SSTABLE简介</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
